package require sqlite3
package require vfs
package require Trf
package require starkit
source zipvfs.tcl
load ./tclsqlitevfs.so

proc testAll {} {
    foreach dbname decomp.db archive compressed.zip vfsroot /virtual {}
    puts "deleting database $dbname, if it was here..."
    file delete $dbname

    puts "creating database $dbname..."
    sqlite3 db $dbname
    puts "creating tables..."
    db eval {
	CREATE TABLE Employees(emp_id INTEGER PRIMARY KEY AUTOINCREMENT,
			       emp_name TEXT, emp_surname TEXT);
	CREATE TABLE Computers(comp_id INTEGER PRIMARY KEY AUTOINCREMENT,
			       comp_name TEXT, comp_description TEXT)
    }
    puts "populating them with some crap..."
    db transaction {
	for {set i 0} {$i<40000} {incr i} {
	    set name "Name$i"
	    set surname "Surname$i"
	    set compname "Station$i"
	    set compdesc "Station #$i in my sandbox"
	    db eval { INSERT INTO Employees (emp_name, emp_surname) 
		VALUES($name,$surname) }
	    db eval { INSERT INTO Computers (comp_name, comp_description) 
		VALUES($compname,$compdesc) }
	}
    }
    db close
    puts "deleting $archive if it was here..."
    file delete $archive
    puts "zipping $dbname into $archive..."
    exec zip -9 $archive $dbname
    puts "mounting $archive as $vfsroot..."
    vfs::zip::Mount $archive $vfsroot
    puts "opening it from the VFS..."
    sqlite3 db [file join $vfsroot ./$dbname]
    puts "hey-ho! it works partially, at least..."
    set nEmp [ db onecolumn { SELECT count (*) from EMPLOYEES} ]
    if {$nEmp == 40000} {
	puts "yeeeeah! We have 40000 employees, as it should be. 40000 couries alone!"
    } else {
	puts "mesa do something wrooong, only $nEmp employees left, expected 40000..."
    }
	db close
}

testAll

